'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactAddonsPureRenderMixin = require('react-addons-pure-render-mixin');

var _reactMotion = require('react-motion');

var _HeightReporter = require('./HeightReporter');

var _HeightReporter2 = _interopRequireDefault(_HeightReporter);

var Collapse = _react2['default'].createClass({
  displayName: 'Collapse',

  propTypes: {
    isOpened: _react2['default'].PropTypes.bool.isRequired,
    children: _react2['default'].PropTypes.node.isRequired,
    style: _react2['default'].PropTypes.object
  },

  getDefaultProps: function getDefaultProps() {
    return { style: {} };
  },

  getInitialState: function getInitialState() {
    return { height: 0, dirty: true };
  },

  componentWillMount: function componentWillMount() {
    this.height = '0.00';
  },

  componentWillReceiveProps: function componentWillReceiveProps() {
    this.setState({ dirty: true });
  },

  shouldComponentUpdate: _reactAddonsPureRenderMixin.shouldComponentUpdate,

  onUpdate: function onUpdate() {
    this.setState({ dirty: true });
  },

  onHeightReady: function onHeightReady(height) {
    this.setState({ height: height, dirty: false });
  },

  renderHeightReporter: function renderHeightReporter() {
    if (!this.state.dirty && this.state.height) {
      return null;
    }

    return _react2['default'].createElement(
      _HeightReporter2['default'],
      { onHeightReady: this.onHeightReady },
      this.props.children
    );
  },

  render: function render() {
    var _this = this;

    var _props = this.props;
    var isOpened = _props.isOpened;
    var style = _props.style;

    var props = _objectWithoutProperties(_props, ['isOpened', 'style']);

    var height = this.state.height;

    return _react2['default'].createElement(
      'div',
      null,
      this.renderHeightReporter(),
      _react2['default'].createElement(
        _reactMotion.Motion,
        { defaultStyle: { height: 0 }, style: { height: (0, _reactMotion.spring)(isOpened ? height : 0) } },
        function (st) {
          _this.height = parseFloat(st.height).toFixed(2);
          if (!isOpened && !st.height) {
            return null;
          }

          var newStyle = _this.height !== parseFloat(height).toFixed(2) ? {
            height: st.height,
            overflow: 'hidden'
          } : { height: 'auto' };

          return _react2['default'].createElement('div', _extends({ style: _extends({}, style, newStyle) }, props));
        }
      )
    );
  }
});

exports['default'] = Collapse;
module.exports = exports['default'];
//# sourceMappingURL=Collapse.js.map