'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactAddonsPureRenderMixin = require('react-addons-pure-render-mixin');

var HeightReporter = _react2['default'].createClass({
  displayName: 'HeightReporter',

  propTypes: {
    children: _react2['default'].PropTypes.node.isRequired,
    onHeightReady: _react2['default'].PropTypes.func.isRequired
  },

  componentDidMount: function componentDidMount() {
    this.height = this.refs.wrapper.offsetHeight;
    if (this.height > 0) {
      return this.props.onHeightReady(this.height);
    }
  },

  shouldComponentUpdate: _reactAddonsPureRenderMixin.shouldComponentUpdate,

  componentDidUpdate: function componentDidUpdate() {
    if (this.refs.wrapper.offsetHeight > 0 && this.refs.wrapper.offsetHeight !== this.height) {
      this.height = this.refs.wrapper.offsetHeight;
      return this.props.onHeightReady(this.height);
    }
  },

  render: function render() {
    return _react2['default'].createElement(
      'div',
      { style: { height: 0, overflow: 'hidden' } },
      _react2['default'].createElement(
        'div',
        { ref: 'wrapper' },
        this.props.children
      )
    );
  }
});

exports['default'] = HeightReporter;
module.exports = exports['default'];
//# sourceMappingURL=HeightReporter.js.map